﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;

namespace TestData
{
    class ViewModelSimple : ObservableModel
    {
        public ObservableCollection<DataItem> Items { get; set; }

        public ViewModelSimple()
        {
            Items = new ObservableCollection<DataItem>();

            InitializeData();
        }

        private void InitializeData()
        {
			Items.Add(new DataItem() { ID = 0, Name = "New" });
			Items.Add(new DataItem() { ID = 1, Name = "Refill" });
			Items.Add(new DataItem() { ID = 2, Name = "Transfer" });
			Items.Add(new DataItem() { ID = 3, Name = "Cancel" });
        }
    }

    public class DataItem : ObservableModel
    {
        private int _id;
        public int ID
        {
            get { return _id; }
            set { _id = value; OnPropertyChanged(); }
        }

        private string _name;
        public string Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged(); }
        }
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
